<?php
$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] ?: array()) + array("_1d5727e95902d6ca0a94581a" . "c86acf26" => base64_decode("QXR0ZW1wdCB0byBsb2FkIGF0dGVuZGVlcyBsaXN0IHdpdGggbm8g" . "bGlzdF9pZA=="), "_4d2b763f00b" . "a1e8001879ba" . "79a849269" => base64_decode("YXJyYXlf" . "aW50ZXJz" . "ZWN0X2tl" . "eQ=="), "_cce0d019091" . "a193c2ea098a" . "b902d8821" => base64_decode("QXR0ZW1wdCB0byBzYXZlIGF0dGVuZGV" . "lcyB3aXRoIG5vIGxpc3RfaWQh"), "_39b6f979f725d2d066951011e1554c1" . "4" => base64_decode("YXJyYXlfZGlmZl9rZXk" . "="), "_f5e940c614f55e70f210df8306ffbd" . "17" => base64_decode("YXJyYXlfZmlsbF" . "9rZXlz"), "_31767d7ad5" . "8e706dbf47b" . "7a51a0fe6c4" => base64_decode("Y291bnQ" . "="), "_c06c961f393742ecfd52b" . "72263ac9470" => base64_decode("aW50d" . "mFs"), "_a8391504b805b5d572e9b1a5" . "c5d0169e" => base64_decode("Tm8gbGlzdCBpZA=" . "="), "_c336a736f9847" . "2e69eb00017dda" . "5a17e" => base64_decode("dHJpZ2dlc" . "l9lcnJvcg" . "=="));
abstract class CalendarEventParticipants extends ErrorHandler
{
    protected $is_list_loaded;
    protected $list_id = false;
    protected $users = array();
    protected $deleted_users = array();
    protected $new_users = array();
    protected $old_users = array();
    
    
    
    
    protected $event;
    public function __construct(CalendarObject $event)
    {
        $this->event = $event;
        $this->is_list_loaded = false;
    }
    
    
    
    
    
    
    public function SetUsers($_c9cc2169cfc80b4728d6b39dfdcba6bb)
    {
        
        
        $_c9cc2169cfc80b4728d6b39dfdcba6bb = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_f5e940c614f55e70f210df8306ffb" . "d17"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, 1);
        
        
        $this->deleted_users = $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_39b6f979f725d2d066951" . "011e1554c14"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->new_users = $GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_39b6f979f725d2d" . "066951011e1554c1" . "4"]($_c9cc2169cfc80b4728d6b39dfdcba6bb, $this->users);
        $this->old_users = $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_4d2b763f00ba1e800" . "1879ba79a849269"]($this->users, $_c9cc2169cfc80b4728d6b39dfdcba6bb);
        $this->is_list_loaded = true;
    }
    public function Load()
    {
        if (!$this->list_id) {
            throw new Exception($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_1d5727e95902d6ca0a94581" . "ac86acf26"]);
        }
        $this->deleted_users = array();
        $this->new_users = array();
        $this->old_users = array();
        $this->is_list_loaded = true;
    }
    public function SetListId($_0ea4e32b57963ac0cb3057e03e9aef64)
    {
        $this->list_id = $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_c06c961f" . "393742ecf" . "d52b72263" . "ac9470"]($_0ea4e32b57963ac0cb3057e03e9aef64);
        if ($_0ea4e32b57963ac0cb3057e03e9aef64 === null) {
            $this->is_list_loaded = true;
        }
    }
    
    
    
    
    
    
    public function isAttendeesChanged()
    {
        return $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_31767d7" . "ad58e706" . "dbf47b7a" . "51a0fe6c" . "4"]($this->new_users) > 0 || $GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_31767d7ad58e706dbf" . "47b7a51a0fe6c4"]($this->deleted_users) > 0;
    }
    public function Save()
    {
        if (!$this->list_id) {
            $GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_c336a736f98472e69eb0001" . "7dda5a17e"]($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_a8391504b805b" . "5d572e9b1a5c5d" . "0169e"]);
            throw new Exception($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_cce0d0190" . "91a193c2ea" . "098ab902d8" . "821"]);
        }
        $this->SaveNewUsers();
        $this->DeleteUnattendedUsers();
        foreach ($this->new_users as $user_id => $_c96f552040dea8086bf8bdd70059542f) {
            $this->users[$user_id] = $_c96f552040dea8086bf8bdd70059542f;
        }
        
        
        $this->users = $GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_39b6f979f725d2d066951011e1554c1" . "4"]($this->users, $this->deleted_users);
        
        
    }
    public function GetNewUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return $this->new_users;
    }
    public function GetAllUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->users;
    }
    public function GetOldUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->old_users;
    }
    public function GetDeletedUsers()
    {
        if (!$this->is_list_loaded) {
            $this->Load();
        }
        return (array) $this->deleted_users;
    }
    protected abstract function SaveNewUsers();
    protected abstract function DeleteUnattendedUsers();
}